// Generated by dts-bundle v0.7.3-fork.1
// Dependencies for this module:
//   ../../../../../@fullcalendar/core
//   ../../../../../preact
//   ../../../../../@fullcalendar/daygrid

declare module '@fullcalendar/timegrid' {
    import TimeColsView from '@fullcalendar/timegrid/TimeColsView';
    import DayTimeColsView, { buildTimeColsModel } from '@fullcalendar/timegrid/DayTimeColsView';
    import TimeColsSeg from '@fullcalendar/timegrid/TimeColsSeg';
    import { default as DayTimeCols, DayTimeColsSlicer, buildDayRanges } from '@fullcalendar/timegrid/DayTimeCols';
    
    export { DayTimeCols, DayTimeColsView, TimeColsView, buildTimeColsModel, buildDayRanges, DayTimeColsSlicer, TimeColsSeg };
    export { default as TimeCols } from '@fullcalendar/timegrid/TimeCols';
    export { TimeSlatMeta, buildSlatMetas } from '@fullcalendar/timegrid/TimeColsSlats';
    export { default as TimeColsSlatsCoords } from '@fullcalendar/timegrid/TimeColsSlatsCoords';
    const _default: import("@fullcalendar/core").PluginDef;
    export default _default;
}

declare module '@fullcalendar/timegrid/TimeColsView' {
    import { h, VNode, ChunkContentCallbackArgs, DateComponent, ViewProps } from '@fullcalendar/core';
    import AllDaySplitter from '@fullcalendar/timegrid/AllDaySplitter';
    import { TimeSlatMeta } from '@fullcalendar/timegrid/TimeColsSlats';
    export { TimeColsView as default, TimeColsView };
    abstract class TimeColsView extends DateComponent<ViewProps> {
        protected allDaySplitter: AllDaySplitter;
        protected headerElRef: import("preact").RefObject<HTMLTableCellElement>;
        renderSimpleLayout(headerRowContent: VNode | null, allDayContent: ((contentArg: ChunkContentCallbackArgs) => VNode) | null, timeContent: ((contentArg: ChunkContentCallbackArgs) => VNode) | null): h.JSX.Element;
        renderHScrollLayout(headerRowContent: VNode | null, allDayContent: ((contentArg: ChunkContentCallbackArgs) => VNode) | null, timeContent: ((contentArg: ChunkContentCallbackArgs) => VNode) | null, colCnt: number, dayMinWidth: number, slatMetas: TimeSlatMeta[]): h.JSX.Element;
        handleScrollTopRequest: (scrollTop: number) => void;
        getAllDayMaxEventProps(): {
            dayMaxEvents: any;
            dayMaxEventRows: any;
        };
        renderHeadAxis: () => h.JSX.Element;
        renderTableRowAxis: (rowHeight?: number) => h.JSX.Element;
    }
}

declare module '@fullcalendar/timegrid/DayTimeColsView' {
    import { h, DateProfileGenerator, DateProfile, ComponentContext, DayTableModel, ViewProps } from '@fullcalendar/core';
    import TimeColsView from '@fullcalendar/timegrid/TimeColsView';
    export { DayTimeColsView as default, DayTimeColsView };
    class DayTimeColsView extends TimeColsView {
        render(props: ViewProps, state: {}, context: ComponentContext): h.JSX.Element;
    }
    export function buildTimeColsModel(dateProfile: DateProfile, dateProfileGenerator: DateProfileGenerator): DayTableModel;
}

declare module '@fullcalendar/timegrid/TimeColsSeg' {
    import { DateMarker, Seg, EventSegUiInteractionState } from '@fullcalendar/core';
    export default interface TimeColsSeg extends Seg {
        col: number;
        start: DateMarker;
        end: DateMarker;
    }
    export function splitSegsByCol(segs: TimeColsSeg[] | null, colCnt: number): TimeColsSeg[][];
    export function splitInteractionByCol(ui: EventSegUiInteractionState | null, colCnt: number): EventSegUiInteractionState[];
}

declare module '@fullcalendar/timegrid/DayTimeCols' {
    import { h, VNode, DateComponent, DateProfile, EventStore, EventUiHash, EventInteractionState, DateSpan, DateRange, DayTableModel, DateEnv, Slicer, Hit, ComponentContext, CssDimValue, Duration } from '@fullcalendar/core';
    import TimeColsSeg from '@fullcalendar/timegrid/TimeColsSeg';
    import { TimeSlatMeta } from '@fullcalendar/timegrid/TimeColsSlats';
    export interface DayTimeColsProps {
        dateProfile: DateProfile | null;
        dayTableModel: DayTableModel;
        axis: boolean;
        slotDuration: Duration;
        slatMetas: TimeSlatMeta[];
        businessHours: EventStore;
        eventStore: EventStore;
        eventUiBases: EventUiHash;
        dateSelection: DateSpan | null;
        eventSelection: string;
        eventDrag: EventInteractionState | null;
        eventResize: EventInteractionState | null;
        tableColGroupNode: VNode;
        tableMinWidth: CssDimValue;
        clientWidth: number | null;
        clientHeight: number | null;
        expandRows: boolean;
        onScrollTopRequest?: (scrollTop: number) => void;
        forPrint: boolean;
    }
    export { DayTimeCols as default, DayTimeCols };
    class DayTimeCols extends DateComponent<DayTimeColsProps> {
        render(props: DayTimeColsProps, state: {}, context: ComponentContext): h.JSX.Element;
        handleRootEl: (rootEl: HTMLDivElement) => void;
        queryHit(positionLeft: number, positionTop: number): Hit;
    }
    export function buildDayRanges(dayTableModel: DayTableModel, dateProfile: DateProfile, dateEnv: DateEnv): DateRange[];
    export class DayTimeColsSlicer extends Slicer<TimeColsSeg, [DateRange[]]> {
        sliceRange(range: DateRange, dayRanges: DateRange[]): TimeColsSeg[];
    }
}

declare module '@fullcalendar/timegrid/TimeCols' {
    import { h, VNode, Ref, DateMarker, ComponentContext, BaseComponent, EventSegUiInteractionState, DateProfile, CssDimValue, PositionCache, ScrollRequest, DateRange, Duration } from '@fullcalendar/core';
    import { TableCellModel } from '@fullcalendar/daygrid';
    import { TimeSlatMeta } from '@fullcalendar/timegrid/TimeColsSlats';
    import TimeColsSlatsCoords from '@fullcalendar/timegrid/TimeColsSlatsCoords';
    import TimeColsSeg from '@fullcalendar/timegrid/TimeColsSeg';
    export interface TimeColsProps {
        dateProfile: DateProfile;
        cells: TableCellModel[];
        slotDuration: Duration;
        nowDate: DateMarker;
        todayRange: DateRange;
        businessHourSegs: TimeColsSeg[];
        bgEventSegs: TimeColsSeg[];
        fgEventSegs: TimeColsSeg[];
        dateSelectionSegs: TimeColsSeg[];
        eventSelection: string;
        eventDrag: EventSegUiInteractionState | null;
        eventResize: EventSegUiInteractionState | null;
        rootElRef?: Ref<HTMLDivElement>;
        tableColGroupNode: VNode;
        tableMinWidth: CssDimValue;
        clientWidth: number | null;
        clientHeight: number | null;
        expandRows: boolean;
        nowIndicatorSegs: TimeColsSeg[];
        onScrollTopRequest?: (scrollTop: number) => void;
        forPrint: boolean;
        axis: boolean;
        slatMetas: TimeSlatMeta[];
    }
    interface TimeColsState {
        slatCoords?: TimeColsSlatsCoords;
    }
    export { TimeCols as default, TimeCols };
    class TimeCols extends BaseComponent<TimeColsProps, TimeColsState> {
        render(props: TimeColsProps, state: TimeColsState, context: ComponentContext): h.JSX.Element;
        componentDidMount(): void;
        componentDidUpdate(prevProps: TimeColsProps): void;
        componentWillUnmount(): void;
        handleScrollRequest: (request: ScrollRequest) => boolean;
        handleColCoords: (colCoords: PositionCache) => void;
        handleSlatCoords: (slatCoords: TimeColsSlatsCoords) => void;
        positionToHit(positionLeft: any, positionTop: any): {
            col: any;
            dateSpan: {
                range: {
                    start: Date;
                    end: Date;
                };
                allDay: boolean;
            };
            dayEl: HTMLElement;
            relativeRect: {
                left: any;
                right: any;
                top: any;
                bottom: any;
            };
        };
    }
    export {};
}

declare module '@fullcalendar/timegrid/TimeColsSlats' {
    import { h, VNode, BaseComponent, DateProfile, ComponentContext, Duration, RefMap, CssDimValue, DateMarker, DateEnv } from '@fullcalendar/core';
    import TimeColsSlatsCoords from '@fullcalendar/timegrid/TimeColsSlatsCoords';
    export interface TimeColsSlatsProps extends TimeColsSlatsContentProps {
        clientWidth: number | null;
        minHeight: CssDimValue;
        tableMinWidth: CssDimValue;
        tableColGroupNode: VNode;
        onCoords?: (coords: TimeColsSlatsCoords | null) => void;
    }
    interface TimeColsSlatsContentProps {
        dateProfile: DateProfile;
        axis: boolean;
        slatMetas: TimeSlatMeta[];
    }
    export { TimeColsSlats as default, TimeColsSlats };
    class TimeColsSlats extends BaseComponent<TimeColsSlatsProps> {
        render(props: TimeColsSlatsProps, state: {}, context: ComponentContext): h.JSX.Element;
        componentDidMount(): void;
        componentDidUpdate(): void;
        componentWillUnmount(): void;
        updateSizing(): void;
    }
    export interface TimeColsSlatsBodyProps {
        axis: boolean;
        slatMetas: TimeSlatMeta[];
        slatElRefs: RefMap<HTMLTableRowElement>;
    }
    export class TimeColsSlatsBody extends BaseComponent<TimeColsSlatsBodyProps> {
        render(props: TimeColsSlatsBodyProps, state: {}, context: ComponentContext): h.JSX.Element;
    }
    export function TimeColsAxisCell(props: TimeSlatMeta): h.JSX.Element;
    export interface TimeSlatMeta {
        date: DateMarker;
        time: Duration;
        isoTimeStr: string;
        isLabeled: boolean;
    }
    export function buildSlatMetas(slotMinTime: Duration, slotMaxTime: Duration, labelIntervalInput: any, slotDuration: Duration, dateEnv: DateEnv): TimeSlatMeta[];
    export {};
}

declare module '@fullcalendar/timegrid/TimeColsSlatsCoords' {
    import { PositionCache, DateMarker, DateProfile, Duration } from '@fullcalendar/core';
    import { TimeSlatMeta } from '@fullcalendar/timegrid/TimeColsSlats';
    export { TimeColsSlatsCoords as default, TimeColsSlatsCoords };
    class TimeColsSlatsCoords {
        positions: PositionCache;
        constructor(positions: PositionCache, dateProfile: DateProfile, slatMetas: TimeSlatMeta[]);
        safeComputeTop(date: DateMarker): any;
        computeDateTop(when: DateMarker, startOfDayDate?: DateMarker): any;
        computeTimeTop(duration: Duration): any;
    }
}

declare module '@fullcalendar/timegrid/AllDaySplitter' {
    import { Splitter, EventDef, DateSpan } from '@fullcalendar/core';
    export { AllDaySplitter as default, AllDaySplitter };
    class AllDaySplitter extends Splitter {
        getKeyInfo(): {
            allDay: {};
            timed: {};
        };
        getKeysForDateSpan(dateSpan: DateSpan): string[];
        getKeysForEventDef(eventDef: EventDef): string[];
    }
}

